spandsp: dtmf_rx_state_s Struct Reference

spandsp 0.0.6

Public Attributes | List of all members
dtmf_rx_state_s Struct Reference

`#include <dtmf.h>`

## Public Attributes
digits_rx_callback_t | digits_callback
void * | digits_callback_data
tone_report_func_t | realtime_callback
void * | realtime_callback_data
int | filter_dialtone
float | z350 [2]
float | z440 [2]
float | normal_twist
float | reverse_twist
float | threshold
float | energy
goertzel_state_t | row_out [4]
goertzel_state_t | col_out [4]
uint8_t | last_hit
uint8_t | in_digit
int | current_sample
int | duration
int | lost_digits
int | current_digits
char | digits [MAX_DTMF_DIGITS+1]
logging_state_t | logging
| Error and flow logging control.

## Detailed Description

DTMF digit detector descriptor.

## Member Data Documentation

## ◆ col_out

goertzel_state_t dtmf_rx_state_s::col_out[4]

Tone detector working states for the column tones.

Referenced by dtmf_rx(), dtmf_rx_fillin(), and dtmf_rx_init().

## ◆ current_digits

int dtmf_rx_state_s::current_digits

The number of digits currently in the digit buffer.

Referenced by dtmf_rx(), dtmf_rx_get(), and dtmf_rx_init().

## ◆ current_sample

int dtmf_rx_state_s::current_sample

The current sample number within a processing block.

Referenced by dtmf_rx(), dtmf_rx_fillin(), and dtmf_rx_init().

## ◆ digits

char dtmf_rx_state_s::digits[MAX_DTMF_DIGITS+1]

The received digits buffer. This is a NULL terminated string.

Referenced by dtmf_rx(), dtmf_rx_get(), and dtmf_rx_init().

## ◆ digits_callback

digits_rx_callback_t dtmf_rx_state_s::digits_callback

Optional callback funcion to deliver received digits.

Referenced by dtmf_rx(), and dtmf_rx_init().

## ◆ digits_callback_data

void* dtmf_rx_state_s::digits_callback_data

An opaque pointer passed to the callback function.

Referenced by dtmf_rx(), and dtmf_rx_init().

## ◆ duration

int dtmf_rx_state_s::duration

Tone state duration

Referenced by dtmf_rx(), and dtmf_rx_set_realtime_callback().

## ◆ energy

float dtmf_rx_state_s::energy

The accumlating total energy on the same period over which the Goertzels work.

Referenced by dtmf_rx(), dtmf_rx_fillin(), and dtmf_rx_init().

## ◆ filter_dialtone

int dtmf_rx_state_s::filter_dialtone

TRUE if dialtone should be filtered before processing

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_parms().

## ◆ in_digit

uint8_t dtmf_rx_state_s::in_digit

The confirmed digit we are currently receiving

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_status().

## ◆ last_hit

uint8_t dtmf_rx_state_s::last_hit

The result of the last tone analysis.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_status().

## ◆ lost_digits

int dtmf_rx_state_s::lost_digits

The number of digits which have been lost due to buffer overflows.

Referenced by dtmf_rx(), and dtmf_rx_init().

## ◆ normal_twist

float dtmf_rx_state_s::normal_twist

Maximum acceptable "normal" (lower bigger than higher) twist ratio.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_parms().

## ◆ realtime_callback

tone_report_func_t dtmf_rx_state_s::realtime_callback

Optional callback funcion to deliver real time digit state changes.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_set_realtime_callback().

## ◆ realtime_callback_data

void* dtmf_rx_state_s::realtime_callback_data

An opaque pointer passed to the real time callback function.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_set_realtime_callback().

## ◆ reverse_twist

float dtmf_rx_state_s::reverse_twist

Maximum acceptable "reverse" (higher bigger than lower) twist ratio.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_parms().

## ◆ row_out

goertzel_state_t dtmf_rx_state_s::row_out[4]

Tone detector working states for the row tones.

Referenced by dtmf_rx(), dtmf_rx_fillin(), and dtmf_rx_init().

## ◆ threshold

float dtmf_rx_state_s::threshold

Minimum acceptable tone level for detection.

Referenced by dtmf_rx(), dtmf_rx_init(), and dtmf_rx_parms().

## ◆ z350

float dtmf_rx_state_s::z350[2]

350Hz filter state for the optional dialtone filter.

Referenced by dtmf_rx(), and dtmf_rx_parms().

## ◆ z440

float dtmf_rx_state_s::z440[2]

440Hz filter state for the optional dialtone filter.

Referenced by dtmf_rx(), and dtmf_rx_parms().

The documentation for this struct was generated from the following file:

- private/dtmf.h